<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents.html">capabilityAgents</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1settings.html">settings</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html">SQLiteSettingStorage</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_s_q_lite_setting_storage_8h_source.html">SQLiteSettingStorage.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage_inherit__map" id="alexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface.html" title="alexaClientSDK::capability\lAgents::settings::SettingsStorage\lInterface" alt="" coords="5,5,224,57"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage_coll__map" id="alexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface.html" title="alexaClientSDK::capability\lAgents::settings::SettingsStorage\lInterface" alt="" coords="5,5,224,57"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ac9e74195c7dba845b73788ed98251df8"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html#ac9e74195c7dba845b73788ed98251df8">SQLiteSettingStorage</a> (const std::string &amp;databaseFilePath)</td></tr>
<tr class="separator:ac9e74195c7dba845b73788ed98251df8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f9b962779a9596494ebd30614bb4c93"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html#a6f9b962779a9596494ebd30614bb4c93">createDatabase</a> () override</td></tr>
<tr class="separator:a6f9b962779a9596494ebd30614bb4c93"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab959cddcfc479c92f59f9f5510d78ecf"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html#ab959cddcfc479c92f59f9f5510d78ecf">open</a> () override</td></tr>
<tr class="separator:ab959cddcfc479c92f59f9f5510d78ecf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1400fbefbcba79e7cb4f8cd1afda6ad9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html#a1400fbefbcba79e7cb4f8cd1afda6ad9">close</a> () override</td></tr>
<tr class="separator:a1400fbefbcba79e7cb4f8cd1afda6ad9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6750bbf518da12672e84cf51165caa40"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html#a6750bbf518da12672e84cf51165caa40">settingExists</a> (const std::string &amp;key) override</td></tr>
<tr class="separator:a6750bbf518da12672e84cf51165caa40"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae8bf54c9b6ac7c83c1d335a090303327"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html#ae8bf54c9b6ac7c83c1d335a090303327">store</a> (const std::string &amp;key, const std::string &amp;value) override</td></tr>
<tr class="separator:ae8bf54c9b6ac7c83c1d335a090303327"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adc15fb7baccaf07de79ac0d3306a8c82"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html#adc15fb7baccaf07de79ac0d3306a8c82">load</a> (std::unordered_map&lt; std::string, std::string &gt; *mapOfSettings) override</td></tr>
<tr class="separator:adc15fb7baccaf07de79ac0d3306a8c82"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aba638be0e81ee32e311028ac587dc0d2"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html#aba638be0e81ee32e311028ac587dc0d2">modify</a> (const std::string &amp;key, const std::string &amp;value) override</td></tr>
<tr class="separator:aba638be0e81ee32e311028ac587dc0d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a005b035d760d971ccaf0bc06d9f19505"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html#a005b035d760d971ccaf0bc06d9f19505">erase</a> (const std::string &amp;key) override</td></tr>
<tr class="separator:a005b035d760d971ccaf0bc06d9f19505"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8239888aaa8d96ef97fe27258b643ba3"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html#a8239888aaa8d96ef97fe27258b643ba3">clearDatabase</a> () override</td></tr>
<tr class="separator:a8239888aaa8d96ef97fe27258b643ba3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1eca4fdf5d72efc97eeb55b21383c2df"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html#a1eca4fdf5d72efc97eeb55b21383c2df">~SQLiteSettingStorage</a> ()</td></tr>
<tr class="separator:a1eca4fdf5d72efc97eeb55b21383c2df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface.html">alexaClientSDK::capabilityAgents::settings::SettingsStorageInterface</a></td></tr>
<tr class="memitem:a6374b4c301c0c74b38090f4af1fe1e80 inherit pub_methods_classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface.html#a6374b4c301c0c74b38090f4af1fe1e80">~SettingsStorageInterface</a> ()=default</td></tr>
<tr class="separator:a6374b4c301c0c74b38090f4af1fe1e80 inherit pub_methods_classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:acf4410a4814f67caf827c8fe91fcd7db"><td class="memItemLeft" align="right" valign="top">static std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html">SQLiteSettingStorage</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html#acf4410a4814f67caf827c8fe91fcd7db">create</a> (const <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html">avsCommon::utils::configuration::ConfigurationNode</a> &amp;configurationRoot)</td></tr>
<tr class="separator:acf4410a4814f67caf827c8fe91fcd7db"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">An implementation that allows us to store settings using SQLite.</p>
<p class="">This class is not thread-safe. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ac9e74195c7dba845b73788ed98251df8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac9e74195c7dba845b73788ed98251df8">&#9670;&nbsp;</a></span>SQLiteSettingStorage()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage::SQLiteSettingStorage </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>databaseFilePath</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Constructor.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dbFilePath</td><td>The location of the SQLite database file. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a1eca4fdf5d72efc97eeb55b21383c2df"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1eca4fdf5d72efc97eeb55b21383c2df">&#9670;&nbsp;</a></span>~SQLiteSettingStorage()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage::~SQLiteSettingStorage </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a8239888aaa8d96ef97fe27258b643ba3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8239888aaa8d96ef97fe27258b643ba3">&#9670;&nbsp;</a></span>clearDatabase()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage::clearDatabase </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">A utility function to clear the database of all records. Note that the database will still exist, as will the tables. Only the rows will be erased.</p>
<dl class="section return"><dt>Returns</dt><dd>Whether the database was successfully cleared. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface.html#a69418c7410e8e20e894b7ad73347071f">alexaClientSDK::capabilityAgents::settings::SettingsStorageInterface</a>.</p>

</div>
</div>
<a id="a1400fbefbcba79e7cb4f8cd1afda6ad9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1400fbefbcba79e7cb4f8cd1afda6ad9">&#9670;&nbsp;</a></span>close()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage::close </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Close the currently open database, if one is open. </p>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface.html#a238caa6e15c85f44ea846e3f05f9064b">alexaClientSDK::capabilityAgents::settings::SettingsStorageInterface</a>.</p>

</div>
</div>
<a id="acf4410a4814f67caf827c8fe91fcd7db"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acf4410a4814f67caf827c8fe91fcd7db">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html">SQLiteSettingStorage</a> &gt; alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage::create </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1configuration_1_1_configuration_node.html">avsCommon::utils::configuration::ConfigurationNode</a> &amp;&#160;</td>
          <td class="paramname"><em>configurationRoot</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Factory method for creating a storage object for <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings.html">Settings</a> based on an SQLite database.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">configurationRoot</td><td>The global config object. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to the <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_s_q_lite_setting_storage.html">SQLiteSettingStorage</a> object, nullptr if there's an error creating it. </dd></dl>

</div>
</div>
<a id="a6f9b962779a9596494ebd30614bb4c93"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6f9b962779a9596494ebd30614bb4c93">&#9670;&nbsp;</a></span>createDatabase()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage::createDatabase </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Creates a new database. If a database is already being handled by this object or there is another internal error, then this function returns false.</p>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> If the database is created ok, or <code>false</code> if a database is already being handled by this object or there is a problem creating the database. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface.html#a734be9e9d7c39ded86ad6fd610158d8c">alexaClientSDK::capabilityAgents::settings::SettingsStorageInterface</a>.</p>

</div>
</div>
<a id="a005b035d760d971ccaf0bc06d9f19505"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a005b035d760d971ccaf0bc06d9f19505">&#9670;&nbsp;</a></span>erase()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage::erase </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>key</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Erases a single setting from the database.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>The name of the setting to be deleted. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the setting was successfully erased. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface.html#a8ab3a5200347701551282ec5021b42c1">alexaClientSDK::capabilityAgents::settings::SettingsStorageInterface</a>.</p>

</div>
</div>
<a id="adc15fb7baccaf07de79ac0d3306a8c82"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adc15fb7baccaf07de79ac0d3306a8c82">&#9670;&nbsp;</a></span>load()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage::load </td>
          <td>(</td>
          <td class="paramtype">std::unordered_map&lt; std::string, std::string &gt; *&#160;</td>
          <td class="paramname"><em>mapOfSettings</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Loads all settings in the database.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">mapOfSettings</td><td>The map where settings should be stored. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the settings were successfully loaded. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface.html#ab640b356574d41ce995013616cee13d8">alexaClientSDK::capabilityAgents::settings::SettingsStorageInterface</a>.</p>

</div>
</div>
<a id="aba638be0e81ee32e311028ac587dc0d2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aba638be0e81ee32e311028ac587dc0d2">&#9670;&nbsp;</a></span>modify()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage::modify </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Updates a database record of the Setting parameter. The field which is updated by this operation is the value of the particular setting.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>The name of the setting to be modified. </td></tr>
    <tr><td class="paramname">value</td><td>The value of the setting to which it has to be set. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the setting was successfully modified. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface.html#a3f6f22b72b70c6bbaa3c0b82525dfef1">alexaClientSDK::capabilityAgents::settings::SettingsStorageInterface</a>.</p>

</div>
</div>
<a id="ab959cddcfc479c92f59f9f5510d78ecf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab959cddcfc479c92f59f9f5510d78ecf">&#9670;&nbsp;</a></span>open()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage::open </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Open an existing database. If this object is already managing an open database, or there is a problem opening the database, this function returns false.</p>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> If the database is opened ok, <code>false</code> if this object is already managing an open database, or if there is another internal reason the database could not be opened. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface.html#a3d79720861ae81705d4d12d92eee0be3">alexaClientSDK::capabilityAgents::settings::SettingsStorageInterface</a>.</p>

</div>
</div>
<a id="a6750bbf518da12672e84cf51165caa40"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6750bbf518da12672e84cf51165caa40">&#9670;&nbsp;</a></span>settingExists()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage::settingExists </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>key</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Query whether a Setting is currently stored with the given token.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>The name of the setting which uniquely identifies a setting. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> If the setting is stored in the database, <code>false</code> otherwise. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface.html#aaa9c279a8f954f79c5a83befbdc610de">alexaClientSDK::capabilityAgents::settings::SettingsStorageInterface</a>.</p>

</div>
</div>
<a id="ae8bf54c9b6ac7c83c1d335a090303327"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae8bf54c9b6ac7c83c1d335a090303327">&#9670;&nbsp;</a></span>store()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::capabilityAgents::settings::SQLiteSettingStorage::store </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Stores a single <code>Setting</code> in the database.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>The name of the setting. </td></tr>
    <tr><td class="paramname">value</td><td>The value of the setting to which it has to be set. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the setting was successfully stored. </dd></dl>

<p>Implements <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1settings_1_1_settings_storage_interface.html#a5ed149c10ecfe42a3648d5a851e67b8b">alexaClientSDK::capabilityAgents::settings::SettingsStorageInterface</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/CapabilityAgents/Settings/include/Settings/<a class="el" href="_s_q_lite_setting_storage_8h_source.html">SQLiteSettingStorage.h</a></li>
<li>/workplace/avs-device-sdk/CapabilityAgents/Settings/src/<a class="el" href="_s_q_lite_setting_storage_8cpp.html">SQLiteSettingStorage.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
